use strict;
use warnings;
use Test::More;
use lib 't/lib';
use PScm::Test tests => 2;

BEGIN { use_ok('PScm') }

eval_ok(<<EOF, <<EOR, 'error');
(define ^error 0)
(call/cc
  (lambda (cont)
    (begin
      (set! ^error cont))))

(define error
  (lambda (msg)
    (begin
      (print msg)
      (^error ()))))

(define div
  (lambda (numerator denominator)
    (if denominator
        (/ numerator denominator)
        (error "division by zero"))))

(+ (div 2 0) 1)

EOF
^error
PScm::Continuation
error
div
"division by zero"
()
EOR

# vim: ft=perl
